unit unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm2 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Edit0: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label2: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Label3: TLabel;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit30: TEdit;
    Edit31: TEdit;
    Label4: TLabel;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    Edit41: TEdit;
    Edit42: TEdit;
    Edit43: TEdit;
    Label5: TLabel;
    Edit48: TEdit;
    Edit49: TEdit;
    Edit50: TEdit;
    Edit51: TEdit;
    Edit52: TEdit;
    Edit53: TEdit;
    Edit54: TEdit;
    Edit55: TEdit;
    Label6: TLabel;
    Edit60: TEdit;
    Edit61: TEdit;
    Edit62: TEdit;
    Edit63: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Edit68: TEdit;
    Edit69: TEdit;
    Edit70: TEdit;
    Edit71: TEdit;
    Edit72: TEdit;
    Edit73: TEdit;
    Edit74: TEdit;
    Edit75: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    sd: TSaveDialog;
    od: TOpenDialog;
    Edit64: TEdit;
    Edit65: TEdit;
    Edit66: TEdit;
    Edit67: TEdit;
    Edit76: TEdit;
    Edit77: TEdit;
    Edit78: TEdit;
    Edit79: TEdit;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure settings;
   function SaveData: integer;
  end;

const maxir = 80;

type
  TIrData = array [0..maxir] of byte;

var
  irdata: TIrData;
  _ExeName : string;
  _ExeDir : string;
  Form2: TForm2;

function IBox(s: string): integer;
function EBox(s: string): integer;

implementation

{$R *.DFM}


procedure GetExePath;
var S: String;
    i: integer;
begin
 S := ExpandFileName(ParamStr(0));
 _ExeName := ExtractFileName(S);
 for i := length(_exename) downto 1 do
  begin
   if _exename[i] = '.' then
    begin
     _ExeName := Copy(_ExeName,1,i-1);
     break;
    end;
  end;
 _ExeDir := ExtractFilePath(S);
end;

function IBox(s: string): integer;
begin
 result := application.messagebox(PChar(s), 'Information', MB_TOPMOST + mb_iconinformation+mb_ok);
end;

function EBox(s: string): integer;
begin
 result :=  application.messagebox(PChar(s), 'Error', MB_TOPMOST+mb_iconStop+mb_ok);
end;

procedure TForm2.BitBtn2Click(Sender: TObject);
begin
 hide;
end;

function TForm2.SaveData: integer;
var i,j,k: integer;
    e: tedit;
    s: string;
begin
 result := mrok;
 for j := 0 to maxir - 1 do
 for i := 0 to ComponentCount - 1 do begin
  if uppercase(Components[i].Name) = 'EDIT'+inttostr(j) then begin
    e := TEdit(Components[i]);
    s := uppercase(trim(e.text));
    k := strtointdef(s,-1);
    if not (k in [0..255]) then begin
     e.SetFocus;
     EBox(format('Invalid value %d:%s! (0..255)',[j,e.text]));
     result := mrnone;
     exit;
    end else irdata[j] := k;
  end;
 end;
end;

procedure TForm2.BitBtn1Click(Sender: TObject);
begin
 modalresult := SaveData;
end;

procedure TForm2.FormCreate(Sender: TObject);
var i: integer;
begin
 sd.InitialDir := _exedir;
 od.InitialDir := _exedir;
 for i := 0 to ComponentCount - 1 do begin
  if Components[i].ClassName = 'TEdit' then
     TEdit(Components[i]).text := '0x00';
 end;
end;

procedure TForm2.settings;
var i,j: integer;
begin
 for j := 0 to maxir - 1 do
 for i := 0 to ComponentCount - 1 do begin
  if uppercase(Components[i].Name) = 'EDIT'+inttostr(j) then
     TEdit(Components[i]).text := '0x'+inttohex(irdata[j],2);
 end;
end;


procedure TForm2.BitBtn3Click(Sender: TObject);
begin
 FormCreate(sender);
end;

procedure TForm2.BitBtn4Click(Sender: TObject);
var f: file of tirdata;
begin
 if (SaveData = mrok) and sd.Execute then begin
try
   assignfile(f,sd.filename);
   rewrite(f);
   write(f,irdata);
   closefile(f);
except
 on e: exception do ebox(e.message+'  '+syserrormessage(getlasterror));
end;
 end;
end;

procedure TForm2.BitBtn5Click(Sender: TObject);
var f: file of tirdata;
begin
 if od.Execute then begin
try
   assignfile(f,od.filename);
   reset(f);
   read(f,irdata);
   closefile(f);
   settings;
except
 on e: exception do ebox(e.message+'  '+syserrormessage(getlasterror));
end;
 end;
end;


initialization
 GetExePath;

end.
